## ncbi-vdb 2.9.3+dfsg

=== libs/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

by_default: default

TOP ?= $(abspath ..)
MODULE = libs

include $(TOP)/build/Makefile.shell

include $(TOP)/build/Makefile.config

#-------------------------------------------------------------------------------
# default
#
MAIN_SUBDIRS = \
	ext      \
	kfc      \
	klib     \
	kproc    \
	kfs      \
	kns      \
	kfg      \
	krypto   \
	vfs      \
	kapp     \
	kdb      \
	vdb      \
	vxf      \
	search   \
	sraxf    \
	align    \
	axf      \
	wgsxf    \
	ktst     \
	loader   \
	blast    \
	ascp     \
	schema   \
	sra      \
	ngs      \
	ngs-c++  \
	ngs-jni  \
	ngs-py   \
	kxml     \
	hdf5     \
	diagnose \
	tui

NCBI_VDB_SUBDIRS =   \
	$(MAIN_SUBDIRS) \
	ncbi-vdb

SUBDIRS = \
	$(NCBI_VDB_SUBDIRS) \
	vdb-sqlite

# common targets for non-leaf Makefiles; must follow a definition of SUBDIRS
include $(TOP)/build/Makefile.targets

$(SUBDIRS):
	@ $(MAKE) -C $@
	
ncbi-vdb: $(MAIN_SUBDIRS)

vdb-sqlite: $(NCBI_VDB_SUBDIRS)

test:
	@true

.PHONY: default $(SUBDIRS) test

#-------------------------------------------------------------------------------
# pass-through
#
out debug profile release GCC ICC VC++:
	@ $(MAKE) TOP=$(TOP) -f $(TOP)/build/Makefile.env $@

.PHONY: out debug profile release GCC ICC VC++

=== test/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

by_default: runtests

TOP ?= $(abspath ..)
MODULE = test

include $(TOP)/build/Makefile.shell

include $(TOP)/build/Makefile.config

#-------------------------------------------------------------------------------
# default
#
SUBDIRS =       \
    ngs         \
    ktst        \
    cc          \
    ext         \
    judy_test   \
    kfc         \
    kfs         \
    klib        \
    kfg         \
    kapp        \
    vfs         \
    kns         \
    kdb         \
    kproc       \
    vdb         \
    ngs-c++     \
    ngs-java    \
    ngs-python  \
    search      \
    sraxf       \
    vxf         \
    loader      \
    krypto      \
    cipher      \
    install     \
	schema		\

# common targets for non-leaf Makefiles; must follow a definition of SUBDIRS
include $(TOP)/build/Makefile.targets

$(SUBDIRS):
	@ $(MAKE) -C $@

.PHONY: default $(SUBDIRS)

=== libs/align/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(abspath ../..)
MODULE = libs/align

INT_LIBS = \
	libncbi-bam \
	libalign-writer \
	libalign-access \
	libsam-extract \
	libalign-reader

ALL_LIBS = \
	$(INT_LIBS)

OBJFILES =              \
	$(BAM_OBJ)          \
	$(ALIGN_ACCESS_OBJ) \
	$(ALIGN_READER_OBJ) \
	$(ALIGN_WRITER_OBJ)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs compile
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# libncbi-bam
#
$(ILIBDIR)/libncbi-bam: $(addprefix $(ILIBDIR)/libncbi-bam.,$(ILIBEXT))

BAM_SRC = \
	bam

BAM_OBJ = \
	$(addsuffix .$(LOBX),$(BAM_SRC))

BAM_LIB = 

$(ILIBDIR)/libncbi-bam.$(LIBX): $(BAM_OBJ)
	$(LD) --slib -o $@ $^ $(BAM_LIB)


#-------------------------------------------------------------------------------
# align-access
#
$(ILIBDIR)/libalign-access: $(addprefix $(ILIBDIR)/libalign-access.,$(ILIBEXT))

ALIGN_ACCESS_SRC = \
	align-access

ALIGN_ACCESS_OBJ = \
	$(addsuffix .$(LOBX),$(ALIGN_ACCESS_SRC))

ALIGN_ACCESS_LIB = 

$(ILIBDIR)/libalign-access.$(LIBX): $(ALIGN_ACCESS_OBJ)
	$(LD) --slib -o $@ $^ $(ALIGN_ACCESS_LIB)

#-------------------------------------------------------------------------------
# align-reader
#
$(ILIBDIR)/libalign-reader: $(addprefix $(ILIBDIR)/libalign-reader.,$(ILIBEXT))

ALIGN_READER_SRC = \
	align_mgr \
	al_iterator \
	unsupported_pileup_estimator \
	ref_iterator \
	pl_iterator \
	dna-reverse-cmpl \
	reference-cmn \
	reader-cmn \
	reader-refseq \
	reader-wgs \
	reference \
	refseq-mgr \
	quality-quantizer

ALIGN_READER_OBJ = \
	$(addsuffix .$(LOBX),$(ALIGN_READER_SRC))

ALIGN_READER_LIB = 

$(ILIBDIR)/libalign-reader.$(LIBX): $(ALIGN_READER_OBJ)
	$(LD) --slib -o $@ $^ $(ALIGN_READER_LIB)

#-------------------------------------------------------------------------------
# align-writer
#
$(ILIBDIR)/libalign-writer: $(addprefix $(ILIBDIR)/libalign-writer.,$(LIBX))

ALIGN_WRITER_SRC = \
    dna-reverse-cmpl \
	reader-cmn \
	reference-cmn \
	reader-refseq \
	reader-wgs \
	refseq-mgr \
	writer-cmn \
	writer-refseq \
	writer-alignment \
	writer-sequence \
	writer-ref \
	writer-reference

ALIGN_WRITER_OBJ = \
	$(addsuffix .$(LOBX),$(ALIGN_WRITER_SRC))

ALIGN_WRITER_LIB = 

$(ILIBDIR)/libalign-writer.$(LIBX): $(ALIGN_WRITER_OBJ)
	$(LD) --slib -o $@ $^ $(ALIGN_WRITER_LIB)

compile: stdcompile

$(TARGDIR)/compile: $(OBJFILES)

#-------------------------------------------------------------------------------
# samextract
#
$(ILIBDIR)/libsam-extract: $(addprefix $(ILIBDIR)/libsam-extract.,$(LIBX))

SAM_EXTRACT_SRC = \
     samextract-grammar \
     samextract-lex \
     samextract-lib \
     samextract-bam \
     samextract-pool

SAM_EXTRACT_OBJ = \
	$(addsuffix .$(LOBX),$(SAM_EXTRACT_SRC))

SAM_EXTRACT_LIB =

bison:
	bison --no-lines -g -r all -Werror=all \
		-o $(SRCDIR)/samextract-grammar.c \
	--defines=$(SRCDIR)/samextract-tokens.h \
	-v -Wall \
	$(SRCDIR)/samextract-grammar.y

ifeq (dbg,$(BUILD))
  FLEX_DEBUG=-d
endif

flex:
	flex --noline --fast -v -p $(FLEX_DEBUG) \
		-o $(SRCDIR)/samextract-lex.c \
		-DYY_BUF_SIZE=16777216 \
		$(SRCDIR)/samextract-lex.l

$(ILIBDIR)/libsam-extract.$(LIBX): $(SAM_EXTRACT_OBJ)
	$(LD) --slib -o $@ $^ $(SAM_EXTRACT_LIB)

compile: stdcompile

$(TARGDIR)/compile: $(OBJFILES)

=== libs/kfs/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: all

TOP ?= $(abspath ../..)
MODULE = libs/kfs

INT_LIBS = \
	libkfs \
	libkfs-nommap \
	libkff \

ALL_LIBS = \
	$(INT_LIBS)

OBJFILES =           \
	$(KFS_OBJ)       \
	$(KFS_NOMMAP_OBJ)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs compile
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# mmap.c
#  special rule to generate a disabled mmap
#
%.nommap.$(LOBX): %.c
	$(CC) -o $@ -fPIC $(OPT) -DFORCE_MALLOC_MMAP -D_LIBRARY $<


#-------------------------------------------------------------------------------
# kfs
#
$(ILIBDIR)/libkfs: $(addprefix $(ILIBDIR)/libkfs.,$(ILIBEXT))

$(ILIBDIR)/libkfs-nommap: $(addprefix $(ILIBDIR)/libkfs-nommap.,$(LIBX))

KFS_CMN = \
	directory \
	arrayfile \
	file \
	sysdir \
	sysfile \
	sysmmap \
	syslockfile \
	sysdll \
	gzip \
	bzip \
	md5 \
	crc32 \
	arc \
	toc \
	tocentry \
	tocdir \
	tocfile \
	sra \
	tar \
	teefile \
	buffile \
	buffile-read \
	buffile-write \
	subfile \
	nullfile \
	countfile \
	dir_test \
	pagefile \
	pmem \
	readheadfile \
	ramfile \
	extendable-ramfile \
	quickmount \
	report \
	lockfile \
	syslockfile \
	cacheteefile \
	cacheteefile2 \
	rrcachedfile \
	recorder \
	logfile \
	poolpages \
	lru_cache \
	from_to_namelist \
	limitfile

KFS_SRC = \
	mmap \
	$(KFS_CMN)

ifeq (win,$(OS))
	KFS_SRC += directory-path
endif

KFS_NOMMAP_SRC = \
	mmap.nommap \
	$(KFS_CMN)

KFS_OBJ = \
	$(addsuffix .$(LOBX),$(KFS_SRC))

KFS_NOMMAP_OBJ = \
	$(addsuffix .$(LOBX),$(KFS_NOMMAP_SRC))

KFS_LIB = \
	-dkproc \
	-dklib \
	-ddl \
	-dz \
	-dbz2

#	-dsz \

$(ILIBDIR)/libkfs.$(LIBX): $(KFS_OBJ)
	$(LD) --slib -o $@ $^ $(KFS_LIB)

$(ILIBDIR)/libkfs-nommap.$(LIBX): $(KFS_NOMMAP_OBJ)
	$(LD) --slib -o $@ $^ $(KFS_LIB)



#-------------------------------------------------------------------------------
# kfs.2
#
$(ILIBDIR)/libkfs.2: $(addprefix $(ILIBDIR)/libkfs.2.,$(ILIBEXT))

KFS2_SRC = \
	$(KFS_SRC) \
	file-v2 \
	directory-v2 \
	sysfile-v2 
#	sysdir-v2

KFS2_OBJ = \
	$(addsuffix .$(LOBX),$(KFS2_SRC))

KFS2_LIB = \
	$(KFS_LIB)

$(ILIBDIR)/libkfs.2.$(LIBX): $(KFS2_OBJ)
	$(LD) --slib -o $@ $^ $(KFS2_LIB)


#-------------------------------------------------------------------------------
# kff
#
ifeq (1,$(HAVE_MAGIC))

$(ILIBDIR)/libkff: $(addprefix $(ILIBDIR)/libkff.,$(ILIBEXT))

OBJFILES += $(KFF_OBJ)

KFF_SRC = \
	fileformat \
	ffext \
	ffkey \
	ffmagic

KFF_OBJ = \
	$(addsuffix .$(LOBX),$(KFF_SRC))

KFF_LIB = \
	-dkfg \
	-dklib

ifneq (win,$(OS))
	KFF_LIB += -lmagic
endif

$(ILIBDIR)/libkff.$(LIBX): $(KFF_OBJ)
	$(LD) --slib -o $@ $^ $(KFF_LIB)

else

$(ILIBDIR)/libkff:
	@ echo "NOTE - internal library $(@F) cannot be built:"         \
	       "It requires 'libmagic' and its development headers."

endif

compile: stdcompile

$(TARGDIR)/compile: $(OBJFILES)

=== libs/klib/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: all

TOP ?= $(abspath ../..)
MODULE = libs/klib

INT_LIBS = \
	libklib

ALL_LIBS = \
	$(INT_LIBS)

OBJFILES = \
	$(KLIB_OBJ)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all: makedirs compile
	@ $(MAKE) -C $(SRCDIR)/judy all
	@ $(MAKE_CMD) $(TARGDIR)/all

std: makedirs compile
	@ $(MAKE) -C $(SRCDIR)/judy std
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE) -C $(SRCDIR)/judy std
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# all, std
#
$(TARGDIR)/all $(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/all $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean
	@ $(MAKE) -C $(SRCDIR)/judy clean

.PHONY: clean

#-------------------------------------------------------------------------------
# klib
#
$(ILIBDIR)/libklib: $(addprefix $(ILIBDIR)/libklib.,$(ILIBEXT))

KLIB_SRC = \
	text \
	time \
	utf8 \
	iso8859 \
	iso8859-1 \
	cp1252 \
	token \
	symtab \
	container \
	vector \
	namelist \
	all-vdb-version \
	vector_namelist \
	trie \
	pbstree \
	pbstree-impl.nopt \
	pbstree-impl.swap.nopt \
	bstpersist.nopt \
	ptrie.nopt \
	ptpersist.nopt \
	crc32 \
	md5 \
	misc \
	SHA-32bit \
	SHA-64bit \
	qsort \
	ksort \
	bsearch \
	pack \
	unpack \
	vlen-encode \
	data-buffer \
	refcount \
	printf \
	status-rc-strings \
	status-rc \
	syserrcode \
	syswriter \
	out \
	status \
	log \
	writer \
	syslog \
	systime \
	rc-tbl \
	rc-idx-tbl \
	judy-vector \
	report-klib \
	num-gen \
	progressbar \
	sra-release-version \
	hashtable \
	hashfile \
	btree
#	path

ifeq (win,$(OS))
	KLIB_SRC += sysalloc
endif

ifeq (dbg,$(BUILD))
	KLIB_SRC += debug
endif

KLIB_OBJ = \
	$(addsuffix .$(LOBX),$(KLIB_SRC))

KLIB_LIB = \
	-sjudy \
	-lm

$(ILIBDIR)/libklib.$(LIBX): $(KLIB_OBJ)
	$(LD) --slib -o $@ $^ $(KLIB_LIB)


# compilation
compile: makedirs
	@ $(MAKE) -C $(SRCDIR)/judy compile
	@ $(MAKE_CMD) -j$(MAKE_JOBS) $(TARGDIR)/compile

$(TARGDIR)/compile: $(OBJFILES)

=== libs/kns/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: all

TOP ?= $(abspath ../..)
MODULE = libs/kns

INT_LIBS = \
	libkns

ALL_LIBS = \
	$(INT_LIBS)

OBJFILES = \
	$(KNS_OBJ)

include $(TOP)/build/Makefile.env

RWORKDIR = $(TOP)/$(MODULE)

#-------------------------------------------------------------------------------
# outer targets
#

# we are building it on all platforms now, because dependency on libcurl is removed
all std: makedirs compile
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# kns
#
$(ILIBDIR)/libkns: $(addprefix $(ILIBDIR)/libkns.,$(ILIBEXT))

KNS_NO_HTTP_SRC = \
	stream-from-buffer \
	kns_manager-ext \
	manager \
	proxy \
	buffered-stream \
	stream \
	stream-from-files \
	stream-from-streams \
	endpoint \
	sysendpoint \
	syssock \
	sysstream \
	sysmgr \
	tls

ifneq (win,$(OS))
KNS_NO_HTTP_SRC += \
	syspoll
endif

KNS_SRC = \
	$(KNS_NO_HTTP_SRC) \
	http-file          \
	http-client        \
	http-retrier       \
	http               \

KNS_OBJ = \
	$(addsuffix .$(LOBX),$(KNS_SRC))

KNS_LIB = \
    -lkfs \
	-dklib

$(ILIBDIR)/libkns.$(LIBX): $(KNS_OBJ)
	$(LD) --slib -o $@ $^ $(KNS_LIB)


compile: stdcompile

$(TARGDIR)/compile: $(OBJFILES)

=== libs/ktst/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(abspath ../..)
MODULE = libs/ktst

INT_LIBS = \
    libktst

ALL_LIBS = \
	$(INT_LIBS)

OBJFILES = \
	$(TST_OBJ)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs compile
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# testing framework
#
$(ILIBDIR)/libktst: $(addprefix $(ILIBDIR)/libktst.,$(LIBX))

TST_SRC = \
	testenv \
    systestenv \
	testcase \
	testrunner

TST_OBJ = \
	$(addsuffix .$(LOBX),$(TST_SRC))

$(ILIBDIR)/libktst.$(LIBX): $(TST_OBJ)
	$(LP) --slib -o $@ $^ $(TST_LIB)

compile: stdcompile

$(TARGDIR)/compile: $(OBJFILES)

=== libs/ngs-py/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(abspath ../..)
MODULE = libs/ngs-py

INT_LIBS = \
	libngs-py

EXT_LIBS = \

ALL_LIBS = \
	$(INT_LIBS) \
	$(EXT_LIBS)

include $(TOP)/build/Makefile.env

INCDIRS += \
	-I$(SRCDIR)/../ngs

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/all $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# ngs-py
#
$(ILIBDIR)/libngs-py: $(addprefix $(ILIBDIR)/libngs-py.,$(LIBX))

NGS_PY_SRC = \
	py_Manager

NGS_PY_LIB = \

NGS_PY_OBJ = \
	$(addsuffix .$(LOBX),$(NGS_PY_SRC))


$(ILIBDIR)/libngs-py.$(LIBX): $(NGS_PY_OBJ)
	$(LD) --slib -o $@ $^

=== libs/ngs/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: std

TOP ?= $(abspath ../..)
MODULE = libs/ngs

INT_LIBS = \
	libngs

EXT_LIBS = \

ALL_LIBS = \
	$(INT_LIBS) \
	$(EXT_LIBS)

OBJFILES = \
	$(NGS_OBJ)

include $(TOP)/build/Makefile.env

INCDIRS += -I$(TOP)/../ngs/ngs-sdk


#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs compile
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

$(EXT_LIBS): makedirs
	@ $(MAKE_CMD) $(LIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS)) \
	$(addprefix $(LIBDIR)/,$(EXT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# ngs
#  will be included in ncbi-vdb
#
$(ILIBDIR)/libngs: $(addprefix $(ILIBDIR)/libngs.,$(ILIBEXT))

NGS_SRC =                 \
	NCBI-NGS              \
	CSRA1_PileupEvent     \
	CSRA1_Pileup          \
	CSRA1_Alignment       \
	CSRA1_ReferenceWindow \
	CSRA1_Reference       \
	CSRA1_ReadCollection  \
	CSRA1_Read            \
	EBI_ReferenceSequence \
	SRA_Statistics        \
	SRA_DB_ReadCollection \
	SRA_Read              \
	SRA_ReadGroup         \
	SRA_ReadGroupInfo     \
	SRA_ReadCollection    \
	SRA_ReferenceSequence \
	NGS_Statistics        \
	NGS_ReadCollection    \
	NGS_PileupEvent       \
	NGS_Pileup            \
	NGS_ReadGroup         \
	NGS_Alignment         \
	NGS_Reference         \
	NGS_ReferenceSequence \
	NGS_Read              \
	NGS_Fragment          \
	NGS_Cursor            \
	NGS_Refcount          \
	NGS_String            \
	NGS_Id                \
	NGS_ErrBlock          \
	NGS_FragmentBlob      \
	NGS_FragmentBlobIterator    \
    NGS_ReferenceBlob       \
    NGS_ReferenceBlobIterator   \
    VByteBlob               \

NGS_OBJ = \
	$(addsuffix .$(LOBX),$(NGS_SRC))

NGS_LIB = \

$(ILIBDIR)/libngs.$(LIBX): $(NGS_OBJ)
	$(LD) --slib -o $@ $^ $(NGS_LIB)

compile: stdcompile

$(TARGDIR)/compile: $(OBJFILES)

=== libs/schema/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(abspath ../..)
MODULE = libs/schema

INT_LIBS = \
    libschema

ALL_LIBS = \
	$(INT_LIBS)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs compile
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/all $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# schema parser library
#
$(ILIBDIR)/libschema: $(addprefix $(ILIBDIR)/libschema.,$(ILIBEXT))

SCHEMA_SRC = \
    schema-grammar \
    schema-lex \
    Token \
    SchemaScanner \
    SchemaParser \
    ParseTree \
    schema-ast \
    AST \
    ASTBuilder \
    ASTBuilder-type \
    ASTBuilder-func \
    ASTBuilder-phys \
    ASTBuilder-tbl \
    ASTBuilder-db \
	ErrorReport \
	ASTBuilder-view \

schema-grammar.$(LOBX): $(SRCDIR)/schema-grammar.cpp
	$(CP) -o $@ -fPIC $(OPT) -D_LIBRARY $< $(LOC_INFO) -D__file_ext__=cpp

bison: grammar ast

grammar: $(SRCDIR)/schema-grammar.cpp

ast: $(SRCDIR)/schema-ast.cpp

#looak at the major version of Bison
BISON_VERSION = $(word 4,$(subst ., ,$(shell bison -V | grep "(GNU Bison)")))

ifeq (1,$(shell echo "3<=$(BISON_VERSION)" | bc -l))

$(SRCDIR)/schema-grammar.cpp: $(SRCDIR)/schema-grammar.y
	bison -r state -o $(SRCDIR)/schema-grammar.cpp --defines=$(SRCDIR)/schema-tokens.h $(SRCDIR)/schema-grammar.y

$(SRCDIR)/schema-ast.cpp: $(SRCDIR)/schema-ast.y
	bison -r state -o $(SRCDIR)/schema-ast.cpp --defines=$(SRCDIR)/schema-ast-tokens.h $(SRCDIR)/schema-ast.y

else

BISON_ERROR = "NOTE: The current Bison version is $(BISON_VERSION). Version 3.0 or newer is required in the PATH. Using the existing $@."
$(SRCDIR)/schema-grammar.cpp: $(SRCDIR)/schema-grammar.y
	@echo $(BISON_ERROR)

$(SRCDIR)/schema-ast.cpp: $(SRCDIR)/schema-ast.y
	@echo $(BISON_ERROR)

endif

schema-lex.$(LOBX): $(SRCDIR)/schema-lex.c
	$(CC)  -Wno-unused-function -o $@ -fPIC $(OPT) -D_LIBRARY $< $(LOC_INFO) -D__file_ext__=c

flex $(SRCDIR)/schema-lex.c: $(SRCDIR)/schema-lex.l $(SRCDIR)/schema-grammar.cpp
	flex -d -t $(SRCDIR)/schema-lex.l > $(SRCDIR)/schema-lex.c

SCHEMA_OBJ = \
	$(addsuffix .$(LOBX),$(SCHEMA_SRC))

$(ILIBDIR)/libschema.$(LIBX):  $(SCHEMA_OBJ)
	$(LD) --slib -o $@ $^

compile: stdcompile

$(TARGDIR)/compile: $(OBJFILES)

.PHONY: bison flex grammar ast

=== libs/vdb/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(abspath ../..)
MODULE = libs/vdb

INT_LIBS = \
	libvdb \
	libwvdb

ALL_LIBS = \
	$(INT_LIBS)

OBJFILES =     \
	$(VDB_OBJ) \
	$(WVDB_OBJ)

include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs compile
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/all $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# virtual db library
#
$(ILIBDIR)/libvdb: $(addprefix $(ILIBDIR)/libvdb.,$(ILIBEXT))

VDBCMN_SRC = \
	dbmgr-cmn \
	schema-tok \
	schema-parse \
	schema-type \
	schema-func \
	schema-prod \
	schema-expr \
	schema-eval \
	schema-tbl \
	schema-view \
	schema-db \
	schema-dump \
	schema-int \
	schema \
	linker-int \
	linker-cmn \
	database-cmn \
	database-depend \
	database-load \
	table-cmn \
	table-load \
	cursor-cmn \
	column-cmn \
	prod-cmn \
	prod-expr \
	prod-func \
	phys-cmn \
	phys-load \
	blob \
	blob-headers \
	page-map \
	row-id \
	row-len \
	fixed-row-len \
	merge \
	split \
	compare \
	meta-read \
	meta-value \
	meta-attr-read \
	cast \
	range-validate \
	parameter-read \
	redimension \
	index_project \
	index_lookup \
	transpose \
	delta_average \
	report-vdb \
	bytecode \
	view \
	cursor-view \
	cursor-table \

VDB_SRC = \
	$(VDBCMN_SRC) \
	dbmgr \
	linker \
	database \
	table \
	cursor \
	column \
	prod \
	phys

VDB_OBJ = \
	$(addsuffix .$(LOBX),$(VDB_SRC))

VDB_LIB = \
	-dkdb \
	-dvfs \
	-dkfg \
	-dkfs \
	-dkproc \
	-dklib \
	-dz

$(ILIBDIR)/libvdb.$(LIBX): $(VDB_OBJ)
	$(LD) --slib -o $@ $^ $(VDB_LIB)

#-------------------------------------------------------------------------------
# update version
#
$(ILIBDIR)/libwvdb: $(addprefix $(ILIBDIR)/libwvdb.,$(ILIBEXT))

WVDB_SRC = \
	$(VDBCMN_SRC) \
	wdbmgr \
	wlinker \
	wdatabase \
	wtable \
	wcursor \
	wcolumn \
	wprod \
	wphys \
	meta-write \
	meta-attr-write \
	meta-append \
	index_insert

WVDB_OBJ = \
	$(addsuffix .$(LOBX),$(WVDB_SRC))

WVDB_LIB = \
	-dwkdb \
	-dvfs \
	-dkfg \
	-dkfs \
	-dkproc \
	-dklib \
	-dz

$(ILIBDIR)/libwvdb.$(LIBX): $(WVDB_OBJ)
	$(LD) --slib -o $@ $^ $(WVDB_LIB)

compile: stdcompile

$(TARGDIR)/compile: $(OBJFILES)

=== libs/wgsxf/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(abspath ../..)
MODULE = libs/wgsxf

INT_LIBS = \
	libwgsxf \
	libwwgsxf

ALL_LIBS = \
	$(INT_LIBS)

OBJFILES =       \
	$(WGSXF_OBJ) \
	$(WWGSXF_OBJ)

include $(TOP)/build/Makefile.env

RWORKDIR = $(BINDIR)

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs compile
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(TARGDIR)/$@

.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(TARGDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# wgs-vdb transform library
#
$(TARGDIR)/libwgsxf: $(addprefix $(ILIBDIR)/libwgsxf.,$(ILIBEXT))

WGSXF_SRC = \
	build_scaffold \
	build_read_type

WGSXF_OBJ = \
	$(addsuffix .$(LOBX),$(WGSXF_SRC))

WGSXF_LIB = \
	-dvdb \
	-dklib \
	-dm \
	-dz \
	-dbz2

$(ILIBDIR)/libwgsxf.$(LIBX): $(WGSXF_OBJ)
	$(LD) --slib -o $@ $^ $(WGSXF_LIB)

.PHONY: $(TARGDIR)/libwgsxf

#-------------------------------------------------------------------------------
# update-side wgs transform library
#

$(TARGDIR)/libwwgsxf: $(addprefix $(ILIBDIR)/libwwgsxf.,$(ILIBEXT))

WWGSXF_SRC = \
	$(WGSXF_SRC)

WWGSXF_OBJ = \
	$(addsuffix .$(LOBX),$(WWGSXF_SRC))

# temporary
WWGSXF_LIB = \
	-dwvdb \
	-dwkdb \
	-dklib \
	-dm \
	-dz \
	-dbz2

$(ILIBDIR)/libwwgsxf.$(LIBX): $(WWGSXF_OBJ)
	$(LD) --slib -o $@ $^ $(WWGSXF_LIB)

libwwgsxf.vers.h:
	@ true

.PHONY: $(TARGDIR)/libwwgsxf

compile: stdcompile

$(TARGDIR)/compile: $(OBJFILES)

=== debian/control ===
Source: ncbi-vdb
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 12~),
               d-shlibs (>= 0.82),
               libbz2-dev,
               libxml2-dev,
               libhdf5-dev,
               libmagic-dev,
               libngs-sdk-dev,
               libngs-java,
               libmbedtls-dev,
               zlib1g-dev,
               default-jdk-headless
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/med-team/ncbi-vdb
Vcs-Git: https://salsa.debian.org/med-team/ncbi-vdb.git
Homepage: https://github.com/ncbi/ncbi-vdb

Package: libncbi-vdb2
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: libraries for using data in the INSDC Sequence Read Archives
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.

Package: libncbi-vdb-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libncbi-vdb2 (= ${binary:Version}),
         libkdf5-dev (= ${binary:Version}),
         libncbi-wvdb-dev (= ${binary:Version}),
         libaec-dev,
         libbz2-dev,
         zlib1g-dev
Description: libraries for using data in the INSDC Sequence Read Archives (devel)
 Much of the data submitted these days, for example in BAM, Illumina
 export.txt, and Complete Genomics formats, contain alignment
 information. With aligned data, NCBI uses Compression by Reference,
 which only stores the differences in base pairs between sequence data
 and the segment it aligns to. The process to restore original data, for
 example as FastQ, requires fast access to the reference sequences that
 the original data was aligned to. NCBI recommends that SRA users
 dedicate local disk space to store references downloaded from the NCBI
 SRA site. As of Fall 2014, the complete collection of these reference
 sequences is 66 GB. While it isn't usually necessary to download the
 entirety of the reference sequences, this should give you an idea of the
 scale of the storage requirement. By default, the Toolkit will download
 missing reference sequences on demand and cache them in the user's home
 directory. The location of this cache is configurable, as is whether the
 download is automatic or manual.
 .
 This is the development package.

Package: libkdf5-2
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libmbedtls-dev
Description: hdf5 access to data in the INSDC Sequence Read Archives
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 This library is part of the ncbi-vdb package and provides an interface
 to the Hierarchical Data Format 5 (HDF5).

Package: libkdf5-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libkdf5-2 (= ${binary:Version})
Description: hdf5 access to data in the INSDC Sequence Read Archives (devel)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 This library is part of the ncbi-vdb package and provides an interface
 to the Hierarchical Data Format 5 (HDF5).
 .
 This is the development package.

Package: libncbi-wvdb2
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: virtual layer update modul of ncbi-vdb library
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 This library is part of the ncbi-vdb package.

Package: libncbi-wvdb-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libncbi-wvdb2 (= ${binary:Version})
Description: virtual layer update modul of ncbi-vdb library (devel)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 This library is part of the ncbi-vdb package.
 .
 This is the development package.

Package: libvdb-sqlite2
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: sqlite modul of ncbi-vdb library
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 This library is part of the ncbi-vdb package and provides a sqlite
 interface.

Package: libvdb-sqlite-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libvdb-sqlite2 (= ${binary:Version})
Description: sqlite modul of ncbi-vdb library (devel)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 This library is part of the ncbi-vdb package and provides a sqlite
 interface.
 .
 This is the development package.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DH_BUILD_MAINT_OPTIONS := nocheck

# DH_VERBOSE := 1

include /usr/share/dpkg/default.mk

OS := $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)
CPU := $(shell dpkg-architecture -qDEB_BUILD_GNU_CPU)
MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
# since build-results are not ending up in the proper dir its saver to use "*" instead of "$(CPU)"
SODIR := $(DEB_SOURCE)/$(DEB_SOURCE)/$(OS)/gcc
VDB_ARCH := $(word 1, $(subst -, ,$(DEB_HOST_MULTIARCH)))
LIBINSTALLDIR := debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/$(VDB_ARCH)/dbg/lib
LIBPKG := libncbi-vdb2
SCHEMADIR := debian/$(LIBPKG)/usr/lib/$(DEB_SOURCE)

# See debian/patches/fix-linking
# export DEB_LDFLAGS_MAINT_APPEND := -Wl,-z,defs -Wl,--as-needed
export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

%:
	dh $@

override_dh_auto_clean:
	if [ -e ngs-sdk/Makefile.config.$(OS).$(CPU) ] ; then \
		dh_auto_clean ; \
	fi
	rm -rf $(DEB_SOURCE)/$(MULTIARCH)

override_dh_auto_configure:
	# that's no standard configure script lacking support of default options
	# The build system shamelessly ignores those options like
	#    --with-ngs-java-prefix=/usr/share/java
	# so we need to go with patches.  The options are specified anyway.
	ln -s /usr/lib/jvm/default-java/include/jni.h		libs/ngs-jni
	ln -s /usr/lib/jvm/default-java/include/linux/jni_md.h	libs/ngs-jni
	./configure --build=$(MULTIARCH) --prefix=/usr --build-prefix=$(CURDIR)/debian/tmp/usr --with-ngs-sdk-prefix=/usr --with-debug --with-ngs-java-prefix=/usr/share/java
	# no idea how to convince configure script to use the correct include dir so patching result afterwards
	sed -i 's?HDF5_INCDIR = /usr/include?&/hdf5/serial?' build/Makefile.config*

override_dh_auto_build:
	dh_auto_build --no-parallel

override_dh_auto_test:
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	# FIXME: some tests keep on failing despite debian/patches/skip_failing_test.patch - needs to be sorted out later
	dh_auto_test || true
else
	echo "Skip testing which takes a long time"
endif

override_dh_auto_install:
	dh_auto_install
	find $(LIBINSTALLDIR) -name "*-static.a" -delete
	# upstream installs versioned *.a libs - we only want a single version
	for slib in $(LIBINSTALLDIR)/*.a ; do \
	    mv $(LIBINSTALLDIR)/`readlink $$slib` $$slib ; \
	    mv $(LIBINSTALLDIR)/`readlink $$slib` $$slib ; \
	done
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --override s/libmbedx509-0-dev/libmbedtls-dev/ \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/lib/libncbi-ngs-c++.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libkapp.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libkapp-norsrc.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libkff.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libktst.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libkxfs.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libkxml.a usr/lib/$(MULTIARCH) \
                    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libload.a usr/lib/$(MULTIARCH) \
		    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libtui.a usr/lib/$(MULTIARCH) \
                    --movedev debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/ilib/libtui_cpp.a usr/lib/$(MULTIARCH) \
		    --movedev interfaces usr/include \
		    debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/lib/libncbi-vdb.so
	mv debian/libncbi-vdb-dev/usr/include/interfaces debian/libncbi-vdb-dev/usr/include/$(DEB_SOURCE)
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --override s/libhdf5_serial[0-9]*-dev/libhdf5-dev/ \
		    --override s/libmbedx509-0-dev/libmbedtls-dev/ \
		    debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/lib/libkdf5.so
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/lib/libncbi-wvdb.so
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    debian/tmp/usr/$(DEB_SOURCE)/$(OS)/gcc/*/dbg/lib/libvdb-sqlite.so
	find debian/lib* -name .gitignore -delete
	# move schemata from development packages to library packages since these are used in executables
	mkdir -p $(SCHEMADIR)
	set -x ; \
	for schema in `find debian/libncbi-vdb-dev/usr/include/$(DEB_SOURCE) -name "*.vschema"` ; do \
	    schemafile=`basename $${schema}` ; \
	    schemadir=`basename $$(dirname $${schema})` ; \
	    mkdir -p $(SCHEMADIR)/$${schemadir} ; \
	    sed -i "s:^include ':&/usr/lib/ncbi-vdb/:" $${schema} ; \
	    mv $${schema} $(SCHEMADIR)/$${schemadir} ; \
	done

override_missing:
	dh_missing --fail-missing
